% File to reproduce the figures in the text. It is necessary first to run and save the
% results of each model specification considered in the figures.
%
clear, clc
%-----------------------------------------------------
% Figure 5
%-----------------------------------------------------
load('Mod_sel_8_May_2018_VAR4_patternsearch_atilde19')
aBest19 = aBest;
Y4 = Y;
X4 = cell2mat(X(6));
x4 = find(cell2mat(fval(6)) == min(cell2mat(fval(6))));
X4 = X4(x4,:);
best4 = zeros(6,1);
for i = 1:6
    best4(i) = min(cell2mat(fval(i))); 
end
load('Mod_sel_8_May_2018_VAR4_patternsearch_atilde0')
aBest0 = aBest;
figure
plot(h,aBest19,'o-',h,aBest0,'s-',h,h*0,'-',h,h*0+2,'-')
ylim([-.5,2.5]), xticks(h)
xlabel('Months'), ylabel('Annualised inflation rate')
title('Best forecast based on 4-VAR model')
%-----------------------------------------------------
% Figure 6
%-----------------------------------------------------
load('Mod_sel_8_May_2018_VAR1_patternsearch_atilde19')
aBest19 = aBest;
Y1 = Y;
X1 = cell2mat(X(6));
x1 = find(cell2mat(fval(6)) == min(cell2mat(fval(6))));
X1 = X1(x1,:);
best1 = zeros(6,1);
for i = 1:6
    best1(i) = min(cell2mat(fval(i))); 
end
load('Mod_sel_8_May_2018_VAR1_patternsearch_atilde0')
aBest0 = aBest;
figure
plot(h,aBest19,'o-',h,aBest0,'s-',h,h*0,'-',h,h*0+2,'-')
ylim([-.5,2.5]), xticks(h)
xlabel('Months'), ylabel('Annualised inflation rate')
title('Best forecast based on AR model')
%-----------------------------------------------------
% Figure 7
%-----------------------------------------------------
load('Mod_sel_8_May_2018_VAR2_patternsearch_atilde19')
best2 = zeros(6,1);
for i = 1:6
    best2(i) = min(cell2mat(fval(i))); 
end
load('Mod_sel_8_May_2018_VAR3_patternsearch_atilde19')
best3 = zeros(6,1);
for i = 1:6
    best3(i) = min(cell2mat(fval(i))); 
end
figure
plot(h,best4,'o-',h,best3,'s-',h,best2,'d-',h,best1,'-')
xticks(h)
xlabel('Months'), ylabel('Average loss')
legend('4-VAR','3-VAR','2-VAR','AR','Location','northwest')
%-----------------------------------------------------
% Figure 8
%-----------------------------------------------------
[~,aJudgInSample4,~,~,yOut] = VARrisk(X4,Y4,h(6),htilde,atilde,alpha,p); 
[~,aJudgInSample1] = VARrisk(X1,Y1,h(6),htilde,atilde,alpha,p); 
startDate=datenum(Date(h(6)+1),'dd/mm/yyyy');
endDate=datenum(Date(end),'dd/mm/yyyy');
xticks(startDate:(endDate-startDate)/n:endDate)
xData = linspace(startDate,endDate,n-h(6));
figure, plot(xData,yOut,'-',xData,aJudgInSample4,'--',xData,aJudgInSample1,'-.')
datetick('x','yyyy', 'keeplimits')
xlim([xData(h(6)+1),xData(end)])
title('In sample 36 month MA inflation and model forecast')
legend('36 month MA','4-VAR forecast','AR forecast','Location','northeast')